# Contribution Guidelines

Please note that this project is released with a [Contributor Code of Conduct](code-of-conduct.md). By participating in this project you agree to abide by its terms.

# The pull request should have a useful title. Pull requests with `Update readme.md` as title will be closed right away because I'm so tired of nobody reading this document. Please carefully read everything in `Adding to this list`.

## Table of Contents

- [Adding to this list](#adding-to-this-list)
- [Creating your own awesome list](#creating-your-own-awesome-list)
- [Adding something to an awesome list](#adding-something-to-an-awesome-list)
- [Updating your Pull Request](#updating-your-pull-request)

## Adding to this list

Please ensure your pull request adheres to the following guidelines:

- Search previous suggestions before making a new one, as yours may be a duplicate.
- Make an individual pull request for each suggestion.
- Chose corresponding section (Programming Languages or General) for your suggestion.
- Use the following format: `[List Name `**without awesome**`](link)`
- Use the following format for commit message: `Add Language Name` (without 'awesome' or something else).
- New categories or improvements to the existing categorization are welcome.
- Check your spelling and grammar.
- List, after your addition, should be alphabetically.
- The pull request and commit should have a useful title.
- The body of your commit message should contain a link to the repository.

Thank you for your suggestions!

## Creating your own awesome list

To create your own list, check out the [instructions](https://github.com/sindresorhus/awesome/blob/master/create-list.md).

## Adding something to an awesome list

If you have something awesome to contribute to an awesome list, this is how you do it.

You'll need a [GitHub account](https://github.com/join)!

1. Access the awesome list's GitHub page. For example: https://github.com/sindresorhus/awesome
2. Click on the `readme.md` file: ![Step 2 Click on Readme.md](http://i.imgur.com/GhdkURj.png)
3. Now click on the edit icon. ![Step 3 - Click on Edit](http://i.imgur.com/oEgWdc5.png)
4. You can start editing the text of the file in the in-browser editor. Make sure you follow guidelines above. You can use [GitHub Flavored Markdown](https://help.github.com/articles/github-flavored-markdown/). 
5. Say why you're proposing the changes, and then click on "Propose file change". ![Step 5 - Propose Changes](http://i.imgur.com/nGtERxd.png)
6. Submit the [pull request](https://help.github.com/articles/using-pull-requests/)!![Step 6 - Submit pull](http://i.imgur.com/0OW5V7a.png)

## Updating your Pull Request

Sometimes, a maintainer of an awesome list will ask you to edit your Pull Request before it is included. This is normally due to spelling errors or because your PR didn't match the awesome-* list guidelines.

[Here](https://github.com/RichardLitt/knowledge/blob/master/github/amending-a-commit-guide.md) is a write up on how to change a Pull Request, and the different ways you can do that.
